// PG_EntryViewConfig.h: interface for the PG_EntryViewConfig class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PG_ENTRYVIEWCONFIG_H__5335F561_4813_11D3_89E9_A759C758895F__INCLUDED_)
#define AFX_PG_ENTRYVIEWCONFIG_H__5335F561_4813_11D3_89E9_A759C758895F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "oidtable.h"

#define PG_EVAPREF_NONE		0x00
#define PG_EVAPREF_RDN		0x01
#define PG_EVAPREF_TITLE	0x02
#define PG_EVAPREF_SHELLEX	0x04

class PG_EntryViewAttr
{
public:
	PG_EntryViewAttr( QAttrT *pAT, DWORD dwViewPref )
		{
			m_pAT = pAT;
			m_dwViewPref = dwViewPref;
		};

public:
	QAttrT *Type() { return m_pAT; } ;
	DWORD ViewPreference() { return m_dwViewPref; } ;

private:
	QAttrT *m_pAT;
	DWORD m_dwViewPref;
};

class PG_EntryViewClass
{
public:
	PG_EntryViewClass( QOC *pOC, PtrList<PG_EntryViewAttr> &rEVAList );
	virtual ~PG_EntryViewClass();

public:
	BOOL QueryGetEVAList( QOC *pOC, PtrList<PG_EntryViewAttr> &rEVAList );

private:
	QOC *m_pOC;
	PtrList<PG_EntryViewAttr> m_EVAList;
};

class PG_EntryViewConfig  
{
public:
	PG_EntryViewConfig();
	virtual ~PG_EntryViewConfig();

public:
	BOOL Load();
	BOOL Save();

public:
	BOOL QueryGetEVAList
		( QEntry *pEntry, PtrList<PG_EntryViewAttr> &rEVAList );

	BOOL QueryGetEVAList
		( QOC *pOC, PtrList<PG_EntryViewAttr> &rEVAList );

private:
	PtrList<PG_EntryViewClass> m_viewClassList;
};

#endif // !defined(AFX_PG_ENTRYVIEWCONFIG_H__5335F561_4813_11D3_89E9_A759C758895F__INCLUDED_)
