#if !defined(AFX_PG_ENTRYVIEWCTRL_H__5335F560_4813_11D3_89E9_A759C758895F__INCLUDED_)
#define AFX_PG_ENTRYVIEWCTRL_H__5335F560_4813_11D3_89E9_A759C758895F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PG_EntryViewCtrl.h : header file
//

#include "PG_EntryViewConfig.h"
#include "hyperlink.h"

/////////////////////////////////////////////////////////////////////////////
// PG_EntryViewCtrl window

class PG_EntryViewCtrl : public CWnd
{
// Construction
public:
	PG_EntryViewCtrl();
	virtual ~PG_EntryViewCtrl();

// Attributes
public:

// Operations
public:

	void Create( CWnd *pParentWnd, RECT &rect, UINT nId );
	void SetEntry( QEntry *pEntry );
	void ClearEntry();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(PG_EntryViewCtrl)
	//}}AFX_VIRTUAL

// Implementation
public:
	void DrawEntry( CDC *pDC );

private:
	void CreateFonts();
	void DestroyFonts();
	void DrawRDNAttr( PG_EntryViewAttr *pEVA );
	void DrawEntryAttr( PG_EntryViewAttr *pEVA, BOOL bShowType = TRUE );
	void DrawString( CString &str, CFont *pFont, int nXExtra = 0, int nYExtra = 0 );
	void DrawLink( CString &rStr, CString &rLinkStr, CFont *pFont, int nXExtra = 0, int nYExtra = 0 );

private:
	//
	// The entry being displayed
	QEntry *m_pEntry;

	//
	// Stuff used while drawing the entry
	CDC *m_pDC;
	int m_nNextDrawX;
	int m_nNextDrawY;

	// Font for displaying attribute values
	CFont *m_pValueFont;

	// Font for displaying attribute type names
	CFont *m_pTypeFont;

	// Font for displaying title values
	CFont *m_pTitleFont;

	// Temporary font pointer
	CFont *m_pOrigFont;

	// List of current hyperlinks
	PtrList<CHyperlink> m_linkList;

	// Position of first hyperlink in list
	POSITION m_linkPos;

	// Indicates whether entry has been drawn previously
	BOOL m_bFirstPaint;

	// Generated message map functions
protected:
	//{{AFX_MSG(PG_EntryViewCtrl)
	afx_msg void OnPaint();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PG_ENTRYVIEWCTRL_H__5335F560_4813_11D3_89E9_A759C758895F__INCLUDED_)
